/*
 * generated by Xtext
 */
package org.xtext.example.mydsl.formatting;

import org.eclipse.xtext.Keyword;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.formatting.impl.AbstractDeclarativeFormatter;
import org.eclipse.xtext.formatting.impl.FormattingConfig;
import org.eclipse.xtext.util.Pair;
import org.xtext.example.mydsl.services.MyDslGrammarAccess;

/**
 * This class contains custom formatting description.
 * 
 * see : http://www.eclipse.org/Xtext/documentation/latest/xtext.html#formatting
 * on how and when to use it
 * 
 * Also see {@link org.eclipse.xtext.xtext.XtextFormattingTokenSerializer} as an
 * example
 */
public class MyDslFormatter extends AbstractDeclarativeFormatter {

	@Override
	protected void configureFormatting(FormattingConfig c) {
		MyDslGrammarAccess f = (MyDslGrammarAccess) getGrammarAccess();
		// formatting for Comments
		c.setLinewrap(0, 1, 2).before(f.getSL_COMMENTRule());
		c.setLinewrap(0, 1, 2).before(f.getML_COMMENTRule());
		c.setLinewrap(0, 1, 1).after(f.getML_COMMENTRule());
		// find common keywords an specify formatting for them
		for (Pair<Keyword, Keyword> pair : f.findKeywordPairs("(", ")")) {
			c.setNoSpace().after(pair.getFirst());
			c.setNoSpace().before(pair.getSecond());
		}
		for (Keyword keyword : f.findKeywords(",")) {
			c.setNoSpace().before(keyword);
		}
		// spaces between statements in compilation unit
		c.setLinewrap(2).after(f.getModelAccess().getSemicolonKeyword_1());
		c.setNoSpace().before(
				f.getPrimaryExpressionAccess().getLeftParenthesisKeyword_1_1());
		c.setNoSpace().before(
				f.getPrimaryExpressionAccess().getLeftParenthesisKeyword_1_1());

		// block formating
		ParserRule blockRule = f.getBlockRule();
		c.setLinewrap().before(blockRule);
		c.setIndentationIncrement().before(blockRule);
		c.setLinewrap().after(blockRule);
		c.setIndentationDecrement().after(blockRule);
		c.setLinewrap().after(f.getBlockAccess().getSemicolonKeyword_1_0());
	}
}
